#ifndef _bitwise_h
#define _bitwise_h

/* Bit shifting for endianness of 16-bit numbers */
#define LSByte16(x) (x & 0xff)
#define MSByte16(x) ((x >> 8) & 0xff)

/* Build a 16-bit integer out of two bytes */
#define BytesTo16(lsb, msb) ((lsb & 0xff) | ((msb << 8) & 0xff))

/* Break apart a float. Sadly this is UB, but the "correct" way
 * to do this involves actually implementing
 * IEEE 754 in software to do so
 */
#define FloatByte1(x) (((char *) x)[0])
#define FloatByte2(x) (((char *) x)[1])
#define FloatByte3(x) (((char *) x)[2])
#define FloatByte4(x) (((char *) x)[3])

/* This is so much UB it hurts to write */
#define BytesToFloat(f, b1, b2, b3, b4) \
	do {                                \
		((char *) f)[0] = b1;           \
		((char *) f)[1] = b2;           \
		((char *) f)[2] = b3;           \
		((char *) f)[3] = b4;           \
	} while (0);

#endif
